searchNodes=[{"doc":"An elixir implementation of the ChatopsRPC protocol. This repo provides both server side and client side implementations of the protocol for use with Plug and Fawkes respectively.ServersDefine your chatops:defmodule MyApp.Chatops do use ChatopsRPC.Builder namespace :my_app @help &quot;&quot;&quot; echo &lt;text&gt; - Echo some text back to you &quot;&quot;&quot; command :echo, ~r/echo (?&lt;text&gt;.*)?/, fn %{params: args} -&gt; &quot;\#{args[&quot;text&quot;]}&quot; end endAdd the chatops plug to your router or phoenix endpoint:defmodule ChatopsRPC.TestRouter do use Plug.Router forward &quot;/_chatops&quot;, to: ChatopsRPC.Plug, handler: MyApp.Chatops endYou'll also need to add the chatops body parser to your plug parsers:plug Plug.Parsers, parsers: [:urlencoded, :json], pass: [&quot;text/*&quot;], json_decoder: Jason, body_reader: {ChatopsRPC.Plug.BodyReader, :read_body, []}This step is required because chatops rpc needs the full body in order to the client signature.Finally, you'll need to add the server to your application's supervision tree:defmodule MyApp.Application do def start(_, _) do public_key = System.get_env(&quot;CHATOPS_PUBLIC_KEY&quot;) children = [ {ChatopsRPC.Server, [base_url: &quot;YOUR APPS URL&quot;, public_key: public_key]}, ] end endThe server is used to verify client signatures, store nonces, and other stateful tasks.ClientsAdd the chatops handler to your fawkes bot:opts = [ name: TestBot, bot_alias: &quot;.&quot;, adapter: {Fawkes.Adapter.Slack, [token: config.slack_token]}, brain: {Fawkes.Brain.Redis, []}, handlers: [ {ChatopsRPC.Handler, []}, ] ] Fawkes.start_link(opts)Add the client module to your bots supervision tree:defmodule MyBot.Application do @moduledoc false use Application def start(_type, _args) do opts = [ name: TestBot, bot_alias: &quot;.&quot;, adapter: {Fawkes.Adapter.Slack, [token: config.slack_token]}, brain: {Fawkes.Brain.Redis, []}, handlers: [ {ChatopsRPC.Handler, []}, ] ] children = [ {ChatopsRPC.Client, private_key: File.read!(&quot;private_key&quot;)}, {Fawkes, opts}, ] opts = [strategy: :one_for_one, name: TestBot.Supervisor] Supervisor.start_link(children, opts) end endYour bot should now be able to interact with rpc commands and send rpcs to servers.","ref":"ChatopsRPC.html","title":"ChatopsRPC","type":"module"},{"doc":"Provides an api for building chatops into your service or application.","ref":"ChatopsRPC.Builder.html","title":"ChatopsRPC.Builder","type":"module"},{"doc":"Defines a command. Regexes must provide named capture groups. Otherwise captures will be ignored.","ref":"ChatopsRPC.Builder.html#command/3","title":"ChatopsRPC.Builder.command/3","type":"macro"},{"doc":"Defines your applications namespace. This name will be used as the prefix for your commands if no other prefix is given.","ref":"ChatopsRPC.Builder.html#namespace/1","title":"ChatopsRPC.Builder.namespace/1","type":"macro"},{"doc":"Provides the neccessary client processes for signing requests, listing known services, and polling endpoints for changes.","ref":"ChatopsRPC.Client.html","title":"ChatopsRPC.Client","type":"module"},{"doc":"See ChatopsRPC.Client.Store.call/4.","ref":"ChatopsRPC.Client.html#call/4","title":"ChatopsRPC.Client.call/4","type":"function"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"ChatopsRPC.Client.html#child_spec/1","title":"ChatopsRPC.Client.child_spec/1","type":"function"},{"doc":"See ChatopsRPC.Client.Store.debug/2.","ref":"ChatopsRPC.Client.html#debug/2","title":"ChatopsRPC.Client.debug/2","type":"function"},{"doc":"Callback implementation for Supervisor.init/1.","ref":"ChatopsRPC.Client.html#init/1","title":"ChatopsRPC.Client.init/1","type":"function"},{"doc":"See ChatopsRPC.Client.Store.list/1.","ref":"ChatopsRPC.Client.html#list/1","title":"ChatopsRPC.Client.list/1","type":"function"},{"doc":"See ChatopsRPC.Client.Store.poll/3.","ref":"ChatopsRPC.Client.html#poll/3","title":"ChatopsRPC.Client.poll/3","type":"function"},{"doc":"See ChatopsRPC.Client.Store.remove/2.","ref":"ChatopsRPC.Client.html#remove/2","title":"ChatopsRPC.Client.remove/2","type":"function"},{"doc":"","ref":"ChatopsRPC.Client.html#start_link/1","title":"ChatopsRPC.Client.start_link/1","type":"function"},{"doc":"A Fawkes handler that listens for rpc commands.","ref":"ChatopsRPC.Handler.html","title":"ChatopsRPC.Handler","type":"module"},{"doc":"Callback implementation for Fawkes.EventHandler.init/2.","ref":"ChatopsRPC.Handler.html#init/2","title":"ChatopsRPC.Handler.init/2","type":"function"},{"doc":"Plug for adding chatops commands to your application.","ref":"ChatopsRPC.Plug.html","title":"ChatopsRPC.Plug","type":"module"},{"doc":"Callback implementation for Plug.call/2.","ref":"ChatopsRPC.Plug.html#call/2","title":"ChatopsRPC.Plug.call/2","type":"function"},{"doc":"","ref":"ChatopsRPC.Plug.html#handle_request/2","title":"ChatopsRPC.Plug.handle_request/2","type":"function"},{"doc":"Callback implementation for Plug.init/1.","ref":"ChatopsRPC.Plug.html#init/1","title":"ChatopsRPC.Plug.init/1","type":"function"},{"doc":"Custom body reader that stores the message body in plug private. This is required for chatops rpc to do authentication against the signing token provided by the client.Exampleplug Plug.Parsers, parsers: [:urlencoded], body_reader: {ChatopsRPC.Plug.BodyReader, :read_body, []}","ref":"ChatopsRPC.Plug.BodyReader.html","title":"ChatopsRPC.Plug.BodyReader","type":"module"},{"doc":"","ref":"ChatopsRPC.Plug.BodyReader.html#read_body/2","title":"ChatopsRPC.Plug.BodyReader.read_body/2","type":"function"},{"doc":"Provides the necessary server components for verifying client signatures and storing nonces.","ref":"ChatopsRPC.Server.html","title":"ChatopsRPC.Server","type":"module"},{"doc":"","ref":"ChatopsRPC.Server.html#alt_public_key/1","title":"ChatopsRPC.Server.alt_public_key/1","type":"function"},{"doc":"","ref":"ChatopsRPC.Server.html#base_url/1","title":"ChatopsRPC.Server.base_url/1","type":"function"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"ChatopsRPC.Server.html#child_spec/1","title":"ChatopsRPC.Server.child_spec/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1.","ref":"ChatopsRPC.Server.html#init/1","title":"ChatopsRPC.Server.init/1","type":"function"},{"doc":"","ref":"ChatopsRPC.Server.html#public_key/1","title":"ChatopsRPC.Server.public_key/1","type":"function"},{"doc":"","ref":"ChatopsRPC.Server.html#start_link/1","title":"ChatopsRPC.Server.start_link/1","type":"function"},{"doc":"","ref":"ChatopsRPC.Server.html#store_nonce/2","title":"ChatopsRPC.Server.store_nonce/2","type":"function"}]